def inverse(a, n, verbose=False):
  t = 0
  newt = 1
  r = n
  newr = a
  while newr != 0:
    quotient = r / newr
    (t, newt) = (newt, t - quotient * newt) 
    (r, newr) = (newr, r - quotient * newr)
    if verbose: print t, newt, t, newr, n, r
  if r > 1:
    return "a is not invertible"
  if t < 0:
    t = t + n
  return t

if __name__ == "__main__":
  # AES s-box
  #print inverse(149, 2**8) #TODO not working as expected, should return 138?

  # RSA inverse(e, (p1-)*(q-1))
  print inverse(11, 10800)
  print inverse(7, 160)



